routes/web.php
<?php

use App\Http\Controllers\AuthController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\NoteController;
use App\Http\Controllers\TaskController;
use App\Http\Controllers\CategoryController;

Route::group(['middleware' => 'auth'], function () {
    Route::get('/', function () {
        return view('welcome');
    })->name('home');

    // Categories
    Route::resource('categories', CategoryController::class);

    // Notes
    Route::resource('notes', NoteController::class);

    // Tasks`
    Route::resource('tasks', TaskController::class);


    // Logout
    Route::get('logout', [AuthController::class, 'logout'])->name('logout');
});

Route::group(['middleware' => 'guest'], function () {
    Route::get('login', [AuthController::class, 'login'])->name('login');
    Route::post('signin', [AuthController::class, 'signin'])->name('signin');
    Route::get('register', [AuthController::class, 'register'])->name('register');
    Route::post('signup', [AuthController::class, 'signup'])->name('singup');
});

app/Models/Note.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use App\Models\User;
use App\Models\Category;

class Note extends Model
{
    use HasFactory;

    protected $fillable = [
        'user_id',
        'title',
        'content',
        'position',
    ];

    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function categories()
    {
        return $this->belongsToMany(Category::class)->withTimestamps();
    }
}

app/Http/Controllers/NoteController.php
<?php

namespace App\Http\Controllers;

use App\Models\Note;
use App\Models\User;
use App\Models\Category;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use App\Http\Requests\StoreNoteRequest;

class NoteController extends Controller
{
    public function __construct()
    {
        $this->authorizeResource(Note::class, 'note');
    }

    public function index()
    {
        $user = Auth::user();

        $notes = $user->notes()->orderBy('position')->get();

        return view('notes/index', [
            'notes' => $notes,
        ]);
    }

    public function show(Note $note)
    {
        return view('notes/show', [
            'note' => $note,
        ]);
    }

    public function edit(Note $note)
    {
        $user = Auth::user();

        $categories = $user->categories()->get();
        $selected = $note->categories()->pluck('categories.id')->toArray();

        return view('notes/edit', [
            'note' => $note,
            'categories' => $categories,
            'selected' => $selected,
        ]);
    }

    public function create()
    {
        $user = Auth::user();

        $categories = $user->categories()->get();

        return view('notes/create', [
            'categories' => $categories,
        ]);
    }

    public function destroy(Note $note)
    {
        $note->delete();

        return to_route('notes.index');
    }

    public function store(Request $request)
    {
        $user = Auth::user();

        $data = $request -> validate([
            'title' => [
                'required',
                Rule::unique('notes')->where(function ($query) use ($user) {
                    return $query->where('user_id', $user->id);
                })
            ],
            'position' => [
                'required',
                'integer',
            ],

            'content' => [
                'required',
            ],
            'categories' => [
                'required',
                'array',
            ],
            'categories.*' => 'exists:categories,id',
        ]);

        $note = $user->notes()->create($data);
        $note->categories()->attach($data['categories']);

        return to_route('notes.index');
    }

    public function update(Request $request, Note $note)
    {
        $user = Auth::user();

        $data = $request->validate([
            'title' => [
                'required',
                Rule::unique('notes')->where(function ($query) use ($user) {
                    return $query->where('user_id', $user->id);
                })->ignore($note->id),
            ],
            'position' => 'required|integer',
            'content' => [
                'required',
            ],
            'categories' => [
                'required',
                'array',
            ],
            'categories.*' => 'exists:categories,id',
        ]);

        $note->update($data);
        $note->categories()->sync($data['categories']);

        return to_route('notes.index');
    }
}

resources/views/notes/create.blade.php
@extends('layout')

@section('title', 'Create Note')

@section('body')

@include('partials/top-nav', [
    'title' => 'Notes'
])

@include('partials/errors')


    <form action="<?= route('notes.store') ?>" method="post">
        @csrf
        <label for="Title">Title</label>
        <input type="text" name="title" id="title">

        <select name="categories[]" id="categories" multiple>
        <?php foreach ($categories as $category) {?>
            <option  value="<?php echo $category['id'];?>" ><?php echo $category['name'];?></option>
        <?php }?>
        </select>

        <label for="content">Content</label>
        <input type="text" name="content" id="content" width="80" height="100" >

        <label for="position">Position</label>
        <input type="number" name="position" id="position">

        <input type="reset" value="Rest" style="float: left;">
        <input type="submit" value="Create">
    </form>
@endsection

resources/views/notes/edit.blade.php
@extends('layout')

@section('title', 'Edit note')

@section('links')
<a href="{{ route('notes.show', ['note' => $note['id']]) }}">View</a> |
<form class="delete-form" method="post" action="{{ route('notes.destroy', ['note' => $note['id']]) }}">
    @method('DELETE')
    @csrf()

    <input class="delete-btn" type="submit" value="Delete">
</form>
@endsection

@section('body')

@include('partials/top-nav', [
    'title' => 'Notes'
])

@include('partials/errors')

    <form action="<?= route('notes.update', [
        'note' => $note['id'],
    ]) ?>" method="post">
        @method('PUT')
        @csrf()
        <label for="title">Title</label>
        <input type="text" name="title" id="title" value="<?= $note['title'] ?>">

        <select name="categories[]" id="categories" multiple>
        <?php foreach ($categories as $category) {?>
            <?php if (in_array($category['id'], $selected)) { ?>
                <option  value="<?php echo $category['id'];?>" <?= 'selected' ?>><?php echo $category['name'];?></option>
            <?php } else { ?>
                <option  value="<?php echo $category['id'];?>"><?php echo $category['name'];?></option>
            <?php } ?>
        <?php }?>
        </select>

        <label for="title">Content</label>
        <input type="text" name="content" id="content" value="<?= $note['content'] ?>">

        <label for="position">Position</label>
        <input type="number" name="position" id="position" value="<?= $note['position'] ?>">

        <input type="reset" value="Rest" style="float: left;">
        <input type="submit" value="Update">
    </form>
@endsection

resources/views/notes/index.blade.php
@extends('layout')

@section('title', 'All Notes')

@section('links')
<a href="{{ route('notes.create') }}">New Note</a>
@endsection

@section('body')
    @include('partials/top-nav', [
        'title' => 'Notes'
    ])

    <table>
        <tr>
            <th>ID</th>
            <th>Title</th>
            <th>Content</th>
            <th>Position</th>
            <th>Actions</th>
        </tr>
        @foreach ($notes as $note)
        <tr>
            <td>{{ $note['id'] }}</td>
            <td>{{ str_limit($note['title'], 10) }}</td>
            <td>{{ str_limit($note['content'], 10) }}</td>
            <td>{{ $note['position'] }}</td>
            <td>
                <a href="{{ route('notes.edit', [
                    'note' => $note['id']
                ]) }}">Edit</a> |
                <a href="{{ route('notes.show', [
                    'note' => $note['id']
                ]) }}">View</a> |
                <form class="delete-form" method="post" action="{{ route('notes.destroy', [
                    'note' => $note['id']
                ]) }}">
                    @method('DELETE')
                    @csrf()

                    <input class="delete-btn" type="submit" value="Delete">
                </form>
            </td>
        </tr>
        @endforeach
    </table>
@endsection

resources/views/notes/show.blade.php
@extends('layout')

@section('title', 'View note')

@section('links')
<a href="{{ route('notes.edit', ['note' => $note['id']]) }}">Edit</a> |
<form class="delete-form" method="post" action="{{ route('notes.destroy', ['note' => $note['id']]) }}">
    @method('DELETE')
    @csrf()

    <input class="delete-btn" type="submit" value="Delete">
</form>
@endsection

@section('body')
    @include('partials/top-nav', [
        'title' => 'Notes'
    ])
    <div>
        <h3>Title</h3>
        <?= $note['title'] ?>

        <h3>Content</h3>
        <?= $note['content'] ?>

        <h3>Position</h3>
        <?= $note['position'] ?>
    </div>
@endsection